function tabPlay() {
    this.rowTemplate = $("#play_row_template").clone();
    $('#play_row_template').remove();

    //var bRet = external.GetPlayItems();

    $("#clear_playlist_filter").click(function() {
        $("#play_search").val('');
        $("#play_search").focus();
        $("#tab_play a.filter").parent().removeClass('active');
        $("#tab_play a.All").parent().addClass('active');
        $(this).hide();
        tabPlay.updatePlayTab();
    });

    this.updatePlayTab = function() {
        setTimeout(function(){
                $("#play_library").empty();
                var filter = $("#tab_play .filters li.active a").attr('filter').toLowerCase();
                var search_filter = $("#play_search").val().toLowerCase();
               
                $.each(UI.playList, function(i,item) {
                    if (typeof filter !== 'undefined' && filter != 'all' && filter != item.type || (search_filter != "" && item.name.toLowerCase().search(search_filter) == -1)) {
                        return true; //next
                    }
                    var $row = tabPlay.rowTemplate.clone();
                    if (typeof item.thumbnail === 'undefined' || item.thumbnail == '' || item.thumbnailWidth == 0 || item.thumbnailHeight == 0) {
                       $row.find('.thumbnail').attr("src", 'img/no-thumb-'+item.type+'.png');
                    } else {
                        var scaledWidth  = item.thumbnailWidth;
                        var scaledHeight = item.thumbnailHeight;
                        if (scaledWidth < scaledHeight)
                        {
                            $row.find('.thumbnail').parent().removeClass('img-holder').addClass('img-holder-height');    
                        }
                        $row.find('.thumbnail').attr("src", item.thumbnail);                        
                    }
                    $row.attr("id",'play_'+i).on("click", function() {
                        external.OpenFileDefault(item.file);
                    });
                    $row.find('.title').text(item.name);
                    $row.find('.open-file').attr("title",item.name);
                    $row.find('.open-file').on("click", function() {
                        external.OpenFileDefault(item.file);
                    })

                    if ( typeof item.length !== 'undefined' && item.length != "" ) {
                        $row.find('.duration').text('duration: ' + item.length);
                    } else {
                        $row.find('.duration').text('duration: ?');
                    }

                    var strExt = "";
                    if ( typeof item.extension !== 'undefined' && item.extension != "" ) {
                        strExt = " (." + item.extension + ")";
                    }
                    
                    if ( typeof item.size !== 'undefined' && item.size != "" ) {
                        $row.find('.size').text('size: ' + bytesToSize(item.size) + strExt);
                    } else {
                        $row.find('.size').text('size: ?' + strExt);
                    }
            
                    $row.appendTo("#play_library");
                }); // for each

                if ($("#play_library li").length == 0) {
                    $('#no_playlist').show();
                } else {
                    $('#no_playlist').hide();
                }
        },1); // setTimeout
    }

    this.filterResults = function(filter) {
        $("#tab_play a.filter").parent().removeClass('active');
        $("#tab_play a." + filter).parent().addClass('active');
        this.updatePlayTab();
    };
    
    this.playItemAdded = function(item) {
        if (typeof item != 'object') {
            item = $.parseJSON(item);
        }
        UI.playList.push(item);
        UI.playList.sort(function(a,b){return parseInt(b.created) - parseInt(a.created)});
        this.insertPlaylistItem(item);
        //this.updatePlayTab();
    };
    
    
    this.insertPlaylistItem = function(item) {
        var i = this.getItemPosition(item);
        var $row = tabPlay.rowTemplate.clone();

        if (typeof item.thumbnail === 'undefined' || item.thumbnail == '' || item.thumbnailWidth == 0 || item.thumbnailHeight == 0) {
            $row.find('.thumbnail').attr("src", 'img/no-thumb-'+item.type+'.png');
        } else {
            var scaledWidth  = item.thumbnailWidth;
            var scaledHeight = item.thumbnailHeight;
            if (scaledWidth < scaledHeight)
            {
                $row.find('.thumbnail').parent().removeClass('img-holder').addClass('img-holder-height');    
            }
            $row.find('.thumbnail').attr("src", item.thumbnail);                        
        }

        $row.attr("id",'play_'+i).on("click", function() {
            external.OpenFileDefault(item.file);
        });
        $row.find('.title').text(item.name);
        $row.find('.open-file').attr("title",item.name);
        $row.find('.open-file').on("click", function() {
            external.OpenFileDefault(item.file);
        })

        if ( typeof item.length !== 'undefined' && item.length != "" ) {
            $row.find('.duration').text('duration: ' + item.length);
        } else {
            $row.find('.duration').text('duration: ?');
        }

        var strExt = "";
        if ( typeof item.extension !== 'undefined' && item.extension != "" ) {
            strExt = " (." + item.extension + ")";
        }
        
        if ( typeof item.size !== 'undefined' && item.size != "" ) {
            $row.find('.size').text('size: ' + bytesToSize(item.size) + strExt);
        } else {
            $row.find('.size').text('size: ?' + strExt);
        }

        var search_keyword = $("#play_search").val().toLowerCase();
        if (search_keyword != "" && item.name.toLowerCase().search(search_keyword) == -1) {
            return;
        }

        if ($('#play_library li').length == 0) {
           $('#play_library').append($row);
        } else {
            $('#play_library li').eq(i-1).after($row);
        }
        $('#no_playlist').hide();
    }

    this.playItemUpdateThumbnail = function(item) {
        if (typeof item != 'object') {
            item = $.parseJSON(item);
        }

        var position;
        $.each(UI.playList, function(i, elm) {
            if ( elm.file == item.file ) {
                position = i;
                return;
            }
        });

        if ( typeof position !== 'undefined' ) {
            if ( typeof item.length !== 'undefined' ) {
                UI.playList[position].length = item.length;
            }

            if ( typeof item.thumbnail !== 'undefined' ) {
                UI.playList[position].thumbnail = item.thumbnail;
            }

            if ( typeof item.size !== 'undefined' ) {
                UI.playList[position].size = item.size;
            }

            if ( typeof item.thumbnailWidth !== 'undefined' ) {
                UI.playList[position].thumbnailWidth = item.thumbnailWidth;
            }

            if ( typeof item.thumbnailHeight !== 'undefined' ) {
                UI.playList[position].thumbnailHeight = item.thumbnailHeight;
            }
            this.updatePlayTab();
        }
    };

    this.playItemDeleted = function(item) {
        var position;
        $.each(UI.playList, function(i, elm) {
            if ( elm.file == item ) {
                position = i;
                return;
            }
        });
    
        if ( typeof position !== 'undefined' ) {
            UI.playList.splice(position,1)
            this.updatePlayTab();
        }
        if ($("#play_library li").length == 0) {
            $('#no_playlist').show();
        }
    }
    
    this.getItemPosition = function(item) {
        var position = -1;
        $.each(UI.playList, function(i, elm) {
            if (elm.file == item.file) {
                position = i;
                return;
            }
        });
        return position;
    }
}

function PlayItemAdded(item) 
{
    tabPlay.playItemAdded(item);
}

function PlayItemDeleted(item) 
{
    tabPlay.playItemDeleted(item);
}

function PlayItemUpdateThumbnail(item)
{
    tabPlay.playItemUpdateThumbnail(item);
}
