function tabSettings() {

    $("#set_default_client").change(function(){
        external.SetDefaultApp(JSON.stringify({"value":$(this).is(':checked')}));
    });
    $("#set_startup").change(function(){
        external.SetStartupApp(JSON.stringify({"value":$(this).is(':checked')}));
    });
    $("#set_upload_speed").blur(function(){
        var saved = external.SetLocalSettings(JSON.stringify({"uploadSpeed":parseInt($(this).val(),10)}));
    });
    $("#set_download_speed").blur(function(){
        var saved = external.SetLocalSettings(JSON.stringify({"downloadSpeed":parseInt($(this).val(),10)}));
    });
    $("#download_folder").click(function(){
        var bRet = external.SetDownloadFolder();
    });
    $("#check_for_update").click(function(){
        CheckForUpdate();
    });

    $("#restore_default_settings").click(function(){
        $("#alert").show();
        $("#alert").find(".message").text('Would you like to reset your settings to their defaults?');
        $('#alert .delete-confirmation a.yes').show().off("click").click(function() {
            var defaultDonloadFolder = external.GetDefaultDownloadFolder();
            if ( typeof defaultDonloadFolder === 'undefined' || defaultDonloadFolder == "" )
                return;

            var t = {
                downloadFolder: defaultDonloadFolder,
                downloadSpeed: 0,
                uploadSpeed: 0
            };


            external.SetDefaultApp(JSON.stringify({"value":true}));
            external.SetStartupApp(JSON.stringify({"value":true}));

            $("#set_default_client").prop('checked', true);
            $("#set_startup").prop('checked', true);

            var status = external.SetLocalSettings(JSON.stringify(t));
            var settings = $.parseJSON(external.GetLocalSettings());
            if ( settings != null && typeof settings !== 'undefined' && typeof settings.downloadSpeed !== 'undefined' && typeof settings.uploadSpeed !== 'undefined' && typeof settings.downloadFolder !== 'undefined' ) {
                $("#set_download_speed").val(settings.downloadSpeed);
                $("#set_upload_speed").val(settings.uploadSpeed);
                $('#download_folder').val(settings.downloadFolder);
            }
            $("#alert, #alert .delete-confirmation a.yes, #alert .delete-confirmation a.no").hide();
        });
        $('#alert .delete-confirmation a.no').show().off("click").click(function() {
            $("#alert, #alert .delete-confirmation a.yes, #alert .delete-confirmation a.no").hide();
        });
    });
    
    $("#set_download_speed, #set_upload_speed").on("keypress", function (e) {
            // get decimal character and determine if negatives are allowed
            var decimal = 0;
            var negative = 0;
            // get the key that was pressed
            var key = e.charCode ? e.charCode : e.keyCode ? e.keyCode : 0;
            // allow enter/return key (only when in an input box)
            if (key == 13 && this.nodeName.toLowerCase() == "input") {
                return true;
            } else if (key == 13) {
                return false;
            }
            var allow = false;
            // allow Ctrl+A
            if ((e.ctrlKey && key == 97) || (e.ctrlKey && key == 65) /* opera */) { return true; }
            // allow Ctrl+X (cut)
            if ((e.ctrlKey && key == 120) || (e.ctrlKey && key == 88) /* opera */) { return true; }
            // allow Ctrl+C (copy)
            if ((e.ctrlKey && key == 99) || (e.ctrlKey && key == 67) /* opera */) { return true; }
            // allow Ctrl+Z (undo)
            if ((e.ctrlKey && key == 122) || (e.ctrlKey && key == 90) /* opera */) { return true; }
            // allow or deny Ctrl+V (paste), Shift+Ins
            if ((e.ctrlKey && key == 118) || (e.ctrlKey && key == 86) /* opera */ || (e.shiftKey && key == 45)) { return true; }
            // if a number was not pressed
            if (key < 48 || key > 57) {
                var value = $(this).val();
                /* '-' only allowed at start and if negative numbers allowed */
                if (value.indexOf("-") !== 0 && negative && key == 45 && (value.length === 0 || parseInt($.fn.getSelectionStart(this), 10) === 0)) { return true; }
                /* only one decimal separator allowed */
                if (decimal && key == decimal.charCodeAt(0) && value.indexOf(decimal) != -1) {
                    allow = false;
                }
                // check for other keys that have special purposes
                if( key != 8 /* backspace */ &&
                    key != 9 /* tab */ &&
                    key != 13 /* enter */ &&
                    key != 35 /* end */ &&
                    key != 36 /* home */ &&
                    key != 37 /* left */ &&
                    key != 39 /* right */ &&
                    key != 46 /* del */ ) 
                
                { 
                    allow = false;
                    
                } else {
                    // for detecting special keys (listed above)
                    // IE does not support 'charCode' and ignores them in keypress anyway
                    if (typeof e.charCode != "undefined") {
                        // special keys have 'keyCode' and 'which' the same (e.g. backspace)
                        if(e.keyCode == e.which && e.which !== 0) {
                            allow = true;
                            // . and delete share the same code, don't allow . (will be set to true later if it is the decimal point)
                            if (e.which == 46) { allow = false; }
                        }
                        // or keyCode != 0 and 'charCode'/'which' = 0
                        else if (e.keyCode !== 0 && e.charCode === 0 && e.which === 0) {
                            allow = true;
                        }
                    }
                }
                // if key pressed is the decimal and it is not already in the field
                if (decimal && key == decimal.charCodeAt(0)) {
                    if (value.indexOf(decimal) == -1) {
                        allow = true;
                    } else {
                        allow = false;
                    }
                }
            } else {
                allow = true;
            }
            return allow;
    });
    
    this.updateForm = function() {
        $("#set_default_client").prop('checked', external.IsDefaultApp());
        $("#set_startup").prop('checked', external.IsStartupApp());

        var settings = $.parseJSON(external.GetLocalSettings());
    
        if ( settings != null && typeof settings !== 'undefined' && typeof settings.downloadSpeed !== 'undefined' && typeof settings.uploadSpeed !== 'undefined' && typeof settings.downloadFolder !== 'undefined' ) {
            $("#set_download_speed").val(settings.downloadSpeed);
            $("#set_upload_speed").val(settings.uploadSpeed);
            $('#download_folder').val(settings.downloadFolder);
        }
    }
}

function SetDownloadFolder(jsonResults)
{
    if ( typeof jsonResults !== 'object' ) {
        jsonResults = $.parseJSON(jsonResults);
    }

    if ( typeof jsonResults === 'undefined' || typeof jsonResults.ret === 'undefined' || typeof jsonResults.value === 'undefined' )
        return;

    if ( jsonResults.ret == "error" ) {
        ShowMessageBox({text:jsonResults.value, type:"error"});
        return;                                                          
    }

    $('#download_folder').val(jsonResults.value);   
    var saved = external.SetLocalSettings(JSON.stringify({"downloadFolder":jsonResults.value}));
}

function CheckForUpdate()
{
    $('#update_status').html("");
    $('#update_status').addClass("checking");       

    
    $.support.cors = true;
    $.ajax({
      url: 'http://www.vuze.com/installer/leap/VuzeLeapUpdate.json',
      type: 'GET',
      async: true,
      cache: false,
      crossDomain: true,
      dataType: "json"
    }).success(function( data ) {
        $('#update_status').removeClass("checking");       
        
        var crtVer = external.GetCurrentVersion();
        var srvVer = data.ver;
        var kitUrl = data.url;
        
        $('#update_window .update-window-ct a.upclose-btn').click(function() {
            $("#update_window").hide();
        });

        $('#update_window .update-window-ct .remind-later a').click(function() {
            $("#update_window").hide();
        });

        if (IsNewVersionAvailable(crtVer, srvVer)) {
            $('#dwnInstaller').hide();
            $('#runInstaller').hide();
            $('#update_window .update-window-ct .install-p a').show();

            $('#update_window').show();

            $('#update_window .update-window-ct .upwin-title').html("Update found: Vuze Leap " + srvVer);

            var updateText = data.wn;                    
            $('#update_window .update-window-ct .upwin-content .wn li').html(updateText);

            $('#update_window .update-window-ct a.upclose-btn').click(function() {
                $("#update_window").hide();
            });

            $('#update_window .update-window-ct .remind-later a').click(function() {
                $("#update_window").hide();
            });

            $('#update_window .update-window-ct .install-p a.install-link').click(function() {
                $('#update_window .update-window-ct .install-p a').hide();
                $('#dwnInstaller img').attr("src", "../img/update-loader.gif");
                $('#dwnInstaller').show();
        
                external.DownloadAndInstall(kitUrl, "/autoupdate");
            });
        } else {
            $('#update_status').html("Up to date");       
        }

    }).fail(function(data){
        $('#update_status').removeClass("checking");       
        $('#update_status').html("Communication failure. Check your connection and try again.");       
    });

        
    var timestamp = Math.round(+new Date()/1000);
    var saved = external.SetLocalSettings(JSON.stringify({"lastCheckForUpdate":timestamp.toString()}));
} // CheckForUpdate

function IsNewVersionAvailable(installed, server)
{
    var a = installed.split('.');
    var b = server.split('.');

    for (var i = 0; i < 4; ++i) {
        if (i < a.length) a[i] = Number(a[i]);
        else a[i] = 0;
    }
    for (var i = 0; i < 4; ++i) {
        if (i < b.length) b[i] = Number(b[i]);
        else b[i] = 0;
    }

    if (a[0] > b[0]) return false;
    if (a[0] < b[0]) return true;

    if (a[1] > b[1]) return false;
    if (a[1] < b[1]) return true;

    if (a[2] > b[2]) return false;
    if (a[2] < b[2]) return true;

    if (a[3] > b[3]) return false;
    if (a[3] < b[3]) return true;

    return false; // the same version is on server
} // IsNewVersionAvailable

function DownloadInstallFinished(bRet)
{
    if ( bRet == false )
    {
        $('#update_window .update-window-ct .install-p a').show();
        $('#dwnInstaller').hide();
    }
    else
    {
        $('#dwnInstaller').hide();
        $('#runInstaller img').attr("src", "../img/input-loader.gif");
        $('#runInstaller').show();
    }
}